
Code     SEGMENT
         ASSUME    cs:Code,ds:Code

; ------ konstanty

IncSour  EQU       6                        ; prustek souadnic interval
IncSour0 EQU       1                        ; prustek souadnic minimln
MaxLine  EQU       40                       ; poet zobrazench ar demonstrace
RozmerB  EQU       80                       ; ka linky v bajtech
DimX     EQU       640                      ; rozmr X
DimY     EQU       350                      ; rozmr Y
NColor   EQU       16                       ; poet barev celkem

; ------ data - offsety od registru BP

XBuffUk  EQU       0                        ; ukazatel v zznamncch
XJMax    EQU       2                        ; poet ar se stejnou barvou

XX1      EQU       4                        ; souadnice X bodu 1
XX2      EQU       6                        ; souadnice X bodu 2
XY1      EQU       8                        ; souadnice Y bodu 1
XY2      EQU       10                       ; souadnice Y bodu 2

XdX1     EQU       12                       ; prustek souadnice X bodu 1
XdX2     EQU       14                       ; prustek souadnice X bodu 2
XdY1     EQU       16                       ; prustek souadnice Y bodu 1
XdY2     EQU       18                       ; prustek souadnice Y bodu 2

XSegVRAM EQU       20                       ; segment videopamti

XRandNum EQU       22                       ; nhodn slo

XColor   EQU       26                       ; aktivn barva ry

XOldVMod EQU       27                       ; pvodn videomd

                                          ;* zde by mla bt sud adresa
XBufX1   EQU       28                       ; zznamnk souadnic X bodu 1
XBufX2   EQU       2*MaxLine+XBufX1         ; zznamnk souadnic X bodu 2
XBufY1   EQU       4*MaxLine+XBufX1         ; zznamnk souadnic Y bodu 1
XBufY2   EQU       6*MaxLine+XBufX1         ; zznamnk souadnic Y bodu 2

         org       100h

; ------ vymazn buffer ar

Start:   mov       di,offset BufX1
         mov       cx,MaxLine*4
         xor       ax,ax
         cld
         rep       stosw

; ------ inicializace videomdu

         mov       ah,0fh
         int       10h
         mov       ds:[OldVMod],al          ; schova pvodnho videomdu
         mov       ax,16
         int       10h

; ------ ukazatel datovch promnnch

         mov       bp,offset Data
         mov       es,ss:[bp+XSegVRAM]      ; segment videopamti

; ------ inicializace genertoru nhody

         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]
         mov       dx,ds:[46eh]
         pop       ds
         mov       word ptr ss:[bp+XRandNum],ax
         mov       word ptr ss:[bp+XRandNum+2],dx

; ------ obsluha zmny barvy

Start4:  dec       word ptr ss:[bp+XJMax]   ; ta stejn barvy
         jnz       Shows1                   ; nen zmna barvy

; ------ nov barva

Shows02: mov       bl,NColor
         call      Random0
         test      al,7
         jz        Shows02                  ; zkaz ern a ed barvy
         mov       ss:[bp+XColor],al        ; barva

; ------ nov poet ar stejn barvy

         mov       bl,80
         call      Random0
         add       ax,20
         mov       ss:[bp+XJMax],ax         ; poet ar se stejnou barvou

; ------ vymazn starch ar

Shows1:  mov       ah,0
         call      DispLine                 ; vymazn starch ar

; ------ posun souadnice X bodu 1

         mov       ax,ss:[bp+XX1]
         add       ax,ss:[bp+XdX1]
         jns       Shows21                  ; nen < 0

         call      RandDX
         jmp       short Shows23

Shows21: cmp       ax,DimX
         jl        Shows22                  ; nen vt ne MaxX

         call      RandDX
         neg       ax
Shows23: mov       ss:[bp+XdX1],ax
         add       ax,ss:[bp+XX1]

Shows22: mov       ss:[bp+XX1],ax           ; nov souadnice X

; ------ posun souadnice Y bodu 1

         mov       ax,ss:[bp+XY1]
         add       ax,ss:[bp+XdY1]
         jns       Shows31                  ; nen < 0

         call      RandDX
         jmp       short Shows33

Shows31: cmp       ax,DimY
         jl        Shows32                  ; nen vt ne MaxX

         call      RandDX
         neg       ax
Shows33: mov       ss:[bp+XdY1],ax
         add       ax,ss:[bp+XY1]

Shows32: mov       ss:[bp+XY1],ax           ; nov souadnice X

; ------ posun souadnice X bodu 2

         mov       ax,ss:[bp+XX2]
         add       ax,ss:[bp+XdX2]
         jns       Shows41                  ; nen < 0

         call      RandDX
         jmp       short Shows43

Shows41: cmp       ax,DimX
         jl        Shows42                  ; nen vt ne MaxX

         call      RandDX
         neg       ax
Shows43: mov       ss:[bp+XdX2],ax
         add       ax,ss:[bp+XX2]

Shows42: mov       ss:[bp+XX2],ax           ; nov souadnice X

; ------ posun souadnice Y bodu 2

         mov       ax,ss:[bp+XY2]
         add       ax,ss:[bp+XdY2]
         jns       Shows51                  ; nen < 0

         call      RandDX
         jmp       short Shows53

Shows51: cmp       ax,DimY
         jl        Shows52                  ; nen vt ne MaxX

         call      RandDX
         neg       ax
Shows53: mov       ss:[bp+XdY2],ax
         add       ax,ss:[bp+XY2]

Shows52: mov       ss:[bp+XY2],ax           ; nov souadnice X

; ------ zobrazen novch ar + schova souadnic

         mov       bx,ss:[bp+XX1]           ; poten pozice
         mov       dx,ss:[bp+XY1]           ; poten linka
         mov       cx,ss:[bp+XX2]           ; koncov pozice
         mov       si,ss:[bp+XY2]           ; koncov linka
         mov       ds:[di+BufX1],bx
         mov       ds:[di+BufY1],dx
         mov       ds:[di+BufX2],cx
         mov       ds:[di+BufY2],si

         mov       ah,ss:[bp+XColor]        ; barva
         call      DispLine

; ------ zven ukazatele v bufferu souadnic

         inc       di
         inc       di
         cmp       di,MaxLine*2
         jb        Shows6
         xor       di,di
Shows6:  mov       ss:[bp+XBuffUk],di       ; nov ukazatel v bufferu

; ------ test peruen programu

         mov       ah,1
         int       16h                      ; test stavu klvesnice
         jnz       Start6                   ; konec programu
         jmp       Start4                   ; nen dn klvesa

; ------ konec programu

Start6:  mov       ah,0
         int       16h                      ; zruen klvesy z bufferu

         mov       al,ss:[bp+XOldVMod]      ; pvodn videomd
         mov       ah,0
         int       10h                      ; nvrat pvodnho videomdu

         mov       dx,offset UvTxt
         mov       ah,9
         int       21h

         int       20h

; -----------------------------------------------------------------------------
;        zobrazen ar v bufferu - barva AH
; -----------------------------------------------------------------------------

DispLine PROC      NEAR

         mov       di,ss:[bp+XBuffUk]       ; ukazatel v bufferu
         mov       bx,ds:[di+BufX1]         ; poten pozice
         mov       dx,ds:[di+BufY1]         ; poten linka
         mov       cx,ds:[di+BufX2]         ; koncov pozice
         mov       si,ds:[di+BufY2]         ; koncov linka
         call      Line                     ; vymazn prvn ry

         sub       dx,DimY-1
         neg       dx
         sub       si,DimY-1
         neg       si
         call      Line                     ; vymazn druh ry
         ret

DispLine ENDP

; *****************************************************************************
;                                   RandDX
;                      generovn nhodnho prustku
; -----------------------------------------------------------------------------
; *****************************************************************************

RandDX   PROC      NEAR

         mov       bl,IncSour
         call      Random0
         add       ax,IncSour0
         ret

RandDX   ENDP

; *****************************************************************************
;                                 Random
;                          genertor nhody
; -----------------------------------------------------------------------------
; VSTUP: BX=interval (poet hodnot)
; VSTUP:AX=nhodn slo
; *****************************************************************************

Random0: mov       bh,0

Random   PROC      NEAR

         push      dx
         push      di

         mov       ax,word ptr ss:[bp+XRandNum]
         mov       di,word ptr ss:[bp+XRandNum+2]
         rol       ax,1
         rol       di,1
         xor       al,ss:[di]
         xor       ah,ss:[di+1]
         xor       di,ax
         mov       word ptr ss:[bp+XRandNum],ax
         mov       word ptr ss:[bp+XRandNum+2],di

         xor       dx,dx
         div       bx
         mov       ax,dx

Random9: pop       di
         pop       dx
         ret

Random   ENDP


; *****************************************************************************
;        Zobrazen ry
; -----------------------------------------------------------------------------
; VSTUP: AH=barva
;        BX=poten pozice
;        CX=koncov pozice
;        DX=poten linka
;        SI=koncov linka
;        ES=segment videopamti
; *****************************************************************************

Line     PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp

; ------ oprava poad souadnic (mus platit Y2 >= Y1)

         cmp       si,dx                    ; koncov linka pod poten ?
         jge       Line1                    ; poad souadnic je OK
         xchg      si,dx                    ; zmna souadnic Y
         xchg      bx,cx                    ; zmna souadnic X
Line1:   sub       si,dx                    ; rozdl souadnic Y2-Y1

; ------ nastaven registru barvy

         push      dx
         mov       dx,3ceh
         mov       al,0
         out       dx,al
         inc       dx
         mov       al,ah                    ; poadovan barva
         out       dx,al
         dec       dx

         mov       al,1
         out       dx,al
         inc       dx
         mov       al,0ffh
         out       dx,al
         pop       dx

; ------ vpoet poten adresy ve videopamti

         push      bx
         push      cx
         mov       ax,RozmerB               ; ka linky v bajtech
         mul       dx                       ; vpoet potenho offsetu linky
         mov       di,ax                    ; poten adresa linky
         mov       cl,bl                    ; pozice bodu - ni slovo
         shr       bx,1
         shr       bx,1
         shr       bx,1                     ; pepoet na offset v bajtech
         add       di,bx                    ; poten adresa k zobrazen

; ------ maskovac bit zatku

         mov       dx,03ceh
         and       cl,7                     ; poten bitov pozice v bajtu
         mov       al,8
         out       dx,al
         inc       dx
         mov       al,80h
         shr       al,cl
         pop       bx
         pop       cx

; ------ rozdl souadnic X a rozlien, zda jde shora vlevo nebo vpravo

         sub       bx,cx                    ; rozdl souadnic X2-X1
         jns       lin1ega0
         jmp       Lin3EGA                  ; jde smrem vlevo

; ------ ra jde shora vpravo


; ------ rozlien, zda jde strm vpravo

lin1ega0:cmp       bx,si                    ; je vt prustek ve smru X ?
         jb        Lin2EGA                  ; jde strm vpravo dol

; ------ ra jde mrn vpravo dol

         mov       cx,bx                    ; urujc je prustek X
         inc       cx                       ; poet krok ry
         shl       si,1                     ; rozdl souadnic dY*2
         mov       bp,si                    ; schova dY*2
         sub       bp,bx                    ; dY*2 - dX
         shl       bx,1                     ; dX*2
         sub       si,bx                    ; dY*2 - dX*2
         add       bx,si                    ; dX*2 + dY*2 - dX*2 = dY*2
         mov       ah,al                    ; maska potenho bitu
Lin1EGA1:or        al,ah
         or        bp,bp
         jns       Lin1EGA2
         add       bp,bx
         jmp       short Lin1EGA3
Lin1EGA2:out       dx,al
         xchg      al,es:[di]
         xor       al,al
         add       di,RozmerB
         add       bp,si
         ror       ah,1
         adc       di,0
         jmp       short Lin1EGA4
Lin1EGA3:ror       ah,1
         jnc       Lin1EGA4
         out       dx,al
         xchg      al,es:[di]
         inc       di
         xor       al,al
Lin1EGA4:loop      Lin1EGA1
         out       dx,al
         xchg      al,es:[di]
         jmp       LinEGA9

; ------ ra jde strm vpravo dol

Lin2EGA: mov       cx,si
         inc       cx
         shl       bx,1
         mov       bp,bx
         sub       bp,si
         shl       si,1
         sub       bx,si
         add       si,bx
Lin2EGA1:push      ax
         out       dx,al
         pop       ax
         xchg      ah,es:[di]
         or        bp,bp
         jns       Lin2EGA3
         add       bp,si
         jmp       short Lin2EGA4
Lin2EGA3:ror       al,1
         adc       di,0
;         out       dx,al
         add       bp,bx
Lin2EGA4:add       di,RozmerB
         loop      Lin2EGA1
         jmp       LinEGA9

; ------ ra jde shora vlevo

Lin3EGA: neg       bx
         cmp       bx,si
         jb        Lin4EGA

; ------ ra jde mrn vlevo

         mov       cx,bx
         inc       cx
         shl       si,1
         mov       bp,si
         sub       bp,bx
         shl       bx,1
         sub       si,bx
         add       bx,si
         mov       ah,al
Lin3EGA1:or        al,ah
         or        bp,bp
         jns       Lin3EGA3
         add       bp,bx
         jmp       short Lin3EGA4
Lin3EGA3:out       dx,al
         xchg      al,es:[di]
         xor       al,al
         add       di,RozmerB
         add       bp,si
         rol       ah,1
         sbb       di,0
         jmp       short Lin3EGA5
Lin3EGA4:rol       ah,1
         jnb       Lin3EGA5
         out       dx,al
         xchg      al,es:[di]
         dec       di
         xor       al,al
Lin3EGA5:loop      Lin3EGA1
         out       dx,al
         xchg      al,es:[di]
         jmp       LinEGA9

; ------ ra jde strm vlevo

Lin4EGA: mov       cx,si
         inc       cx
         shl       bx,1
         mov       bp,bx
         sub       bp,si
         shl       si,1
         sub       bx,si
         add       si,bx
Lin4EGA1:push      ax
         out       dx,al
         pop       ax
         xchg      ah,es:[di]
         or        bp,bp
         jns       Lin4EGA2
         add       bp,si
         jmp       short Lin4EGA3
Lin4EGA2:rol       al,1
         sbb       di,0
;         out       dx,al
         add       bp,bx
Lin4EGA3:add       di,RozmerB
         loop      Lin4EGA1

; ------ konec - nvrat registr

LinEGA9: pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

Line     ENDP

; *****************************************************************************
;
;                            Data
;
; *****************************************************************************

UvTxt    db        'LINES - (c) Miroslav Nemecek 1993',13,10
         db        ' GEMA Soft  Roznov pod Radhostem',13,10
         db        '          - FREEWARE -',13,10
         db        '$'

Data     label     byte

BuffUkaz dw        0                        ; ukazatel v zznamncch

JMax     dw        1                        ; poet ar se stejnou barvou

X1       dw        320                      ; souadnice X bodu 1
X2       dw        20                       ; souadnice X bodu 2
Y1       dw        20                       ; souadnice Y bodu 1
Y2       dw        200                      ; souadnice Y bodu 2

dX1      dw        6                        ; prustek souadnice X bodu 1
dX2      dw        6                        ; prustek souadnice X bodu 2
dY1      dw        6                        ; prustek souadnice Y bodu 1
dY2      dw        6                        ; prustek souadnice Y bodu 2

SegVRAM  dw        0a000h                   ; segment videopamti

RandNum  dd        ?                        ; nhodn slo

Color    db        ?                        ; aktivn barva ry

OldVMod  db        ?                        ; pvodn videomd

BufX1    dw        MaxLine dup (?)          ; zznamnk souadnic X bodu 1
BufX2    dw        MaxLine dup (?)          ; zznamnk souadnic X bodu 2
BufY1    dw        MaxLine dup (?)          ; zznamnk souadnic Y bodu 1
BufY2    dw        MaxLine dup (?)          ; zznamnk souadnic Y bodu 2

Code     ENDS

         END       Start
